# consume-monitor.pl
# Check the rate at which disk space is being consumed on some filesystem

sub get_consume_status
{
return { 'up' => -1 } if (!&foreign_check("mount"));
&foreign_require("mount", "mount-lib.pl");
local $m;
foreach $f (&mount::list_mounted()) {
	$m = $f if ($f->[0] eq $_[0]->{'fs'});
	}
local %consume;
&read_file("$module_config_directory/consume", \%consume);
if ($m) {
	local @sp = &mount::disk_space($m->[2], $m->[0]);
	local $now = time();
	local ($lastfree, $lasttime) = split(/\s+/, $consume{$_[0]->{'fs'}});
	local $rv = { 'up' => 1 };
	if ($lasttime) {
		# Compare with last time
		local $diff = ($lastfree - $sp[1]) / ($now - $lasttime);
		if ($diff > $_[0]->{'rate'}) {
			$rv = { 'up' => 0,
				'desc' => &text('consume_high',
						&nice_size($diff*1024)) };
			}
		}
	$consume{$_[0]->{'fs'}} = "$sp[1] $now";
	&write_file("$module_config_directory/consume", \%consume);
	return $rv;
	}
else {
	return { 'up' => -1,
		 'desc' => $text{'space_nofs'} };
	}
}

sub show_consume_dialog
{
local $found;
&foreign_require("mount", "mount-lib.pl");
print "<tr> <td><b>$text{'space_fs'}</b></td>\n";
print "<td colspan=3><select name=fs>\n";
foreach $f (&foreign_call("mount", "list_mounted")) {
	if ($f->[2] !~ /swap|proc|auto/) {
		printf "<option %s>%s\n",
			$_[0]->{'fs'} eq $f->[0] ? 'selected' : '', $f->[0];
		$found++ if ($_[0]->{'fs'} eq $f->[0]);
		}
	}
printf "<option value='' %s>%s\n",
	$_[0]->{'fs'} && !$found ? 'selected' : '', $text{'space_other'};
print "</select>\n";
printf "<input name=other size=15 value='%s'></td>\n",
	$found ? '' : $_[0]->{'fs'};

print "<td><b>$text{'consume_rate'}</b></td>\n";
print "<td>",&ui_bytesbox("rate", $_[0]->{'rate'}*1024),"</td>\n";

}

sub parse_consume_dialog
{
&depends_check($_[0], "mount");
if ($in{'fs'}) {
	$_[0]->{'fs'} = $in{'fs'};
	}
else {
	$in{'other'} =~ /^\// || &error($text{'space_eother'});
	$_[0]->{'fs'} = $in{'other'};
	}
$in{'rate'} =~ /^[0-9\.]+$/ || &error($text{'consume_erate'});
$_[0]->{'rate'} = $in{'rate'}*$in{'rate_units'}/1024;
}

